package org.dromara.web.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.web.domain.StorageLocation;
import org.dromara.web.domain.bo.StorageLocationBo;
import org.dromara.web.domain.vo.StorageLocationVo;
import org.dromara.web.mapper.StorageLocationMapper;
import org.dromara.web.service.IStorageLocationService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 库位管理Service业务层处理
 *
 * @author Lion Li
 * @date 2025-07-07
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class StorageLocationServiceImpl implements IStorageLocationService {

    private final StorageLocationMapper baseMapper;

    /**
     * 查询库位管理
     *
     * @param id 主键
     * @return 库位管理
     */
    @Override
    public StorageLocationVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询库位管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 库位管理分页列表
     */
    @Override
    public TableDataInfo<StorageLocationVo> queryPageList(StorageLocationBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<StorageLocation> lqw = buildQueryWrapper(bo);
        Page<StorageLocationVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的库位管理列表
     *
     * @param bo 查询条件
     * @return 库位管理列表
     */
    @Override
    public List<StorageLocationVo> queryList(StorageLocationBo bo) {
        LambdaQueryWrapper<StorageLocation> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<StorageLocation> buildQueryWrapper(StorageLocationBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<StorageLocation> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(StorageLocation::getId);
        lqw.like(StringUtils.isNotBlank(bo.getStorageName()), StorageLocation::getStorageName, bo.getStorageName());
        return lqw;
    }

    /**
     * 新增库位管理
     *
     * @param bo 库位管理
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(StorageLocationBo bo) {
        StorageLocation add = MapstructUtils.convert(bo, StorageLocation.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改库位管理
     *
     * @param bo 库位管理
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(StorageLocationBo bo) {
        StorageLocation update = MapstructUtils.convert(bo, StorageLocation.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(StorageLocation entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除库位管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
